#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include "main.h"


extern const uint8_t data_index_html_start[] asm("_binary_data_index_html_start");
extern const uint8_t data_index_html_end[] asm("_binary_data_index_html_end");
extern const uint8_t data_script_js_start[] asm("_binary_data_script_js_start");
extern const uint8_t data_script_js_end[] asm("_binary_data_script_js_end");
extern const uint8_t data_style_css_start[] asm("_binary_data_style_css_start");
extern const uint8_t data_style_css_end[] asm("_binary_data_style_css_end");

bool webserver_protecc;
char *webserver_user;
char *webserver_pass;

AsyncWebServer server(80);
// static AsyncWebSocket ws("/ws");
// static AsyncEventSource events("/events");
//
void handleNotFound(AsyncWebServerRequest *request) {
  request->send(404, "text/plain", "Not found");
}
//
// void onEvent(AsyncWebSocket *server, AsyncWebSocketClient *client, AwsEventType type, void *arg, uint8_t *data, size_t len) {
//     if (type == WS_EVT_CONNECT) {
//         // client connected
//         info("ws[%s][%u] connect\n", server->url(), client->id());
//         // String str = get_settings();
//         // client->printf("%s", str.c_str());
//         client->ping();
//     } else if (type == WS_EVT_DISCONNECT) {
//     // client disconnected
//         info("ws[%s][%u] disconnect: %u\n", server->url(), client->id());
//     } else if (type == WS_EVT_ERROR) {
//     // error was received from the other end
//         info("ws[%s][%u] error(%u): %s\n", server->url(), client->id(),
//         *((uint16_t *)arg), (char *)data);
//     } else if (type == WS_EVT_PONG) {
//     // pong message was received (in response to a ping request maybe)
//         info("ws[%s][%u] pong[%u]: %s\n", server->url(), client->id(), len, (len) ? (char *)data : "");
//     } else if (type == WS_EVT_DATA) {
//     // data packet
//     AwsFrameInfo *info = (AwsFrameInfo *)arg;
//     if (info->final && info->index == 0 && info->len == len) {
//     // the whole message is in a single frame and we got all of it's
//     // data info("ws[%s][%u] %s-message[%llu]: ", server->url(),
//     // client->id(), (info->opcode == WS_TEXT) ? "text" : "binary",
//     // info->len);
//     if (info->opcode == WS_TEXT) {
//         data[len] = 0;
//         info("data: %s\n", (char *)data);
//         //        parse_cmd((char *)data, client);
//     }
//     }
//     }
//   }
//
static void redirectHomeResponse(AsyncWebServerRequest *request, String location) {
  AsyncWebServerResponse *response = request->beginResponse(303, "text/plain", "");
  response->addHeader("Location", location);
  response->addHeader("Access-Control-Allow-Origin", "*");
  request->send(response);
}
//
  static void insertPage(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    uint32_t address = 0;
    int ric = -1;
    int fun = 0;
    bool numeric;
    String message;
    //
    if (request->hasArg("text")) {
        message = request->arg("text");
        message = txHandleUmlauts(message);
    }
    if (request->hasArg("ric")) {
        ric = request->arg("ric").toInt();
        address = ric + 0;
    }
    if (request->hasArg("fun")) {
        fun = request->arg("fun").toInt();
    }
    if (request->hasArg("numeric")) {
      numeric = true;
    }
    Serial.printf("RIC: %d -> %d MSG: %s\n\n", ric, address, message);
   
    if (ric > 0) {
        char *messageText = new char[message.length() + 1]{};
        message.toCharArray(messageText, message.length() + 1);
        // messageText[ message.length() ] = 0x20;
        txControllerInsert(address, fun + 0, numeric, messageText);
        delete []messageText;

        if (request->hasArg("addtx")) {
          txControllerBatchStart();
        }
    }
    redirectHomeResponse(request, "/");
  }
  //
  static void triggerTimeBeacon(AsyncWebServerRequest *request) {
    broadcastTriggerTimeBeacon();
    redirectHomeResponse(request, "/#time");
  }
  
  static void transmit(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    txControllerBatchStart();
    redirectHomeResponse(request, "/");
  }
  static void clearQueue(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    redirectHomeResponse(request, "/");
  }
  static void resetConfigReboot(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    redirectHomeResponse(request, "/");
    create_default_config();
    esp_cpu_reset(1);
    esp_cpu_reset(0);
  }
  static void justReboot(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    redirectHomeResponse(request, "/");
    esp_cpu_reset(1);
    esp_cpu_reset(0);
  }
  //
  static void setAPCfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String ssid, pass;
    //
    if (request->hasArg(keySSID.c_str())) ssid = request->arg(keySSID);
    if (request->hasArg(keyPass.c_str())) pass = request->arg(keyPass);
    cfg_startTransaction();
    cfg_adjust(cfgKeyWiFiAPSSID, ssid);
    cfg_adjust(cfgKeyWiFiAPPass, pass);
    cfg_write();
    redirectHomeResponse(request, "/#wifi");
  }
  static void setWifi1Cfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String ssid, pass;
    //
    if (request->hasArg(keySSID.c_str())) ssid = request->arg(keySSID);
    if (request->hasArg(keyPass.c_str())) pass = request->arg(keyPass);
    cfg_startTransaction();
    cfg_adjust(cfgKeyWiFi1SSID, ssid);
    cfg_adjust(cfgKeyWiFi1Pass, pass);
    cfg_write();
    redirectHomeResponse(request, "/#wifi");
  }
  static void setWifi2Cfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String ssid, pass;
    //
    if (request->hasArg(keySSID.c_str())) ssid = request->arg(keySSID);
    if (request->hasArg(keyPass.c_str())) pass = request->arg(keyPass);
    cfg_startTransaction();
    cfg_adjust(cfgKeyWiFi2SSID, ssid);
    cfg_adjust(cfgKeyWiFi2Pass, pass);
    cfg_write();
    redirectHomeResponse(request, "/#wifi");
  }
  //
  static void setTransmitterCfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    float tx_freq, tx_dev;
    int tx_power, tx_baud, tx_tune;
    bool tx_empty_queue, pocsag_german;
    //
    cfg_startTransaction();
    if (request->hasArg(cfgKeyTXFreq.c_str())) {
      tx_freq = request->arg(cfgKeyTXFreq).toFloat();
      cfg_adjust(cfgKeyTXFreq, tx_freq);
    }
    if (request->hasArg(cfgKeyTXBaud.c_str())) {
      tx_baud = request->arg(cfgKeyTXBaud).toInt();
      cfg_adjust(cfgKeyTXBaud, tx_baud);
    }
    if (request->hasArg(cfgKeyTXTune.c_str())) {
      tx_tune = request->arg(cfgKeyTXTune).toInt();
      cfg_adjust(cfgKeyTXTune, tx_tune);
    }
    if (request->hasArg(cfgKeyTXDeviation.c_str())) {
      tx_dev = request->arg(cfgKeyTXDeviation).toFloat();
      cfg_adjust(cfgKeyTXDeviation, tx_dev);
    }
    if (request->hasArg(cfgKeyTXPower.c_str())) {
      tx_power = request->arg(cfgKeyTXPower).toInt();
      cfg_adjust(cfgKeyTXPower, tx_power);
    }
    if (request->hasArg(cfgKeyTXFlagEmptyQueue.c_str())) {
      tx_empty_queue = request->arg(cfgKeyTXFlagEmptyQueue).equals("on");
      cfg_adjust(cfgKeyTXFlagEmptyQueue, tx_empty_queue);
    } else {
      cfg_adjust(cfgKeyTXFlagEmptyQueue, false);
    }
    if (request->hasArg(cfgKeyFlagPOCSAG_German.c_str())) {
      pocsag_german = request->arg(cfgKeyFlagPOCSAG_German).equals("on");
      cfg_adjust(cfgKeyFlagPOCSAG_German, pocsag_german);
    } else {
      cfg_adjust(cfgKeyFlagPOCSAG_German, false);
    } 
    if (request->hasArg(cfgKeyFlagWebserverProtect.c_str())) {
      bool webserver_protect = request->arg(cfgKeyFlagWebserverProtect).equals("on");
      cfg_adjust(cfgKeyFlagWebserverProtect, webserver_protect);
    } else {
      cfg_adjust(cfgKeyFlagWebserverProtect, false);
    }
    cfg_write();
    redirectHomeResponse(request, "/#config");
  }
  static void setMQTTCfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String mqtt_host, mqtt_user, mqtt_pass, mqtt_topic;
    int mqtt_port;
    //
    cfg_startTransaction();
    if (request->hasArg(cfgKeyMQTTHost.c_str())) {
      mqtt_host = request->arg(cfgKeyMQTTHost);
      cfg_adjust(cfgKeyMQTTHost, mqtt_host);
    }
    if (request->hasArg(cfgKeyMQTTTopic.c_str())) {
      mqtt_topic = request->arg(cfgKeyMQTTTopic);
      cfg_adjust(cfgKeyMQTTTopic, mqtt_topic);
    }
    if (request->hasArg(cfgKeyMQTTUser.c_str())) {
      mqtt_user = request->arg(cfgKeyMQTTUser);
      cfg_adjust(cfgKeyMQTTUser, mqtt_user);
    }
    if (request->hasArg(cfgKeyMQTTPass.c_str())) {
      mqtt_pass = request->arg(cfgKeyMQTTPass);
      cfg_adjust(cfgKeyMQTTPass, mqtt_pass);
    }
    if (request->hasArg(cfgKeyMQTTPort.c_str())) {
      mqtt_port = request->arg(cfgKeyMQTTPort).toInt();
      cfg_adjust(cfgKeyMQTTPort, mqtt_port);
    }
    cfg_write();
    redirectHomeResponse(request, "/#config");
  }
  //
  #if (defined(SMART_POC_MODULE_DWD) || defined(SMART_POC_MODULE_MOWAS))
  static void setDWDMoWaS(AsyncWebServerRequest *request) {
    int broadcast_ric, broadcast_fun;
    bool dwd_enable, mowas_enable;
    int dwd_interval, mowas_interval;
    int dwd_fun, mowas_fun;
    String dwd_region, mowas_region;
    cfg_startTransaction();

    //broadcast
    if (request->hasArg(cfgKeyBroadcastRIC.c_str())) {
      broadcast_ric = request->arg(cfgKeyBroadcastRIC).toFloat();
      cfg_adjust(cfgKeyBroadcastRIC, broadcast_ric);
    }
    // if (request->hasArg("broadcast_fun")) {
    //   broadcast_fun = request->arg("broadcast_fun").toInt();
    //   cfg_adjust("broadcast_fun", broadcast_fun);
    // }

    // dwd
    #ifdef SMART_POC_MODULE_DWD
    if (request->hasArg(cfgKeyDWDEnable.c_str())) {
      dwd_enable = request->arg(cfgKeyDWDEnable).equals("on");
      cfg_adjust(cfgKeyDWDEnable, dwd_enable);
    } else {
      cfg_adjust(cfgKeyDWDEnable, false);
    }
    if (request->hasArg(cfgKeyDWDInterval.c_str())) {
      dwd_interval = request->arg(cfgKeyDWDInterval).toInt();
      cfg_adjust(cfgKeyDWDInterval, dwd_interval);
    }
    if (request->hasArg(cfgKeyDWDFunction.c_str())) {
      dwd_fun = request->arg(cfgKeyDWDFunction).toInt();
      cfg_adjust(cfgKeyDWDFunction, dwd_fun);
    }
    if (request->hasArg(cfgKeyDWDRegion.c_str())) {
      dwd_region = request->arg(cfgKeyDWDRegion);
      cfg_adjust(cfgKeyDWDRegion, dwd_region);
    }
    #endif
    #ifdef SMART_POC_MODULE_MOWAS
    // mowas
    if (request->hasArg(cfgKeyMoWaSEnable.c_str())) {
      mowas_enable = request->arg(cfgKeyMoWaSEnable).equals("on");
      cfg_adjust(cfgKeyMoWaSEnable, mowas_enable);
    } else {
      cfg_adjust(cfgKeyMoWaSEnable, false);
    }
    if (request->hasArg(cfgKeyMoWaSInterval.c_str())) {
      mowas_interval = request->arg(cfgKeyMoWaSInterval).toInt();
      cfg_adjust(cfgKeyMoWaSInterval, mowas_interval);
    }
    if (request->hasArg(cfgKeyMoWaSFunction.c_str())) {
      mowas_fun = request->arg(cfgKeyMoWaSFunction).toInt();
      cfg_adjust(cfgKeyMoWaSFunction, mowas_fun);
    }
    if (request->hasArg(cfgKeyMoWaSRegion.c_str())) {
      mowas_region = request->arg(cfgKeyMoWaSRegion);
      cfg_adjust(cfgKeyMoWaSRegion, mowas_region);
    }
    #endif
    
    cfg_write();
    redirectHomeResponse(request, "/#dwdmowas");
  }
  #endif
  #ifdef SMART_POC_MODULE_DWD_WX
  static void setDWDWX(AsyncWebServerRequest *request) {
    bool dwdwx_enable;
    float dwdwx_lat, dwdwx_lng;
    int dwdwx_fun;
    cfg_startTransaction();
    // dwdwx
    if (request->hasArg(cfgKeyDWDWXEnable.c_str())) {
      dwdwx_enable = request->arg(cfgKeyDWDWXEnable).equals("on");
      cfg_adjust(cfgKeyDWDWXEnable, dwdwx_enable);
    } else {
      cfg_adjust(cfgKeyDWDWXEnable, false);
    }
    if (request->hasArg(cfgKeyDWDWXLatitude.c_str())) {
      dwdwx_lat = request->arg(cfgKeyDWDWXLatitude).toFloat();
      cfg_adjust(cfgKeyDWDWXLatitude, dwdwx_lat);
    }
    if (request->hasArg(cfgKeyDWDWXLongitude.c_str())) {
      dwdwx_lng = request->arg(cfgKeyDWDWXLongitude).toFloat();
      cfg_adjust(cfgKeyDWDWXLongitude, dwdwx_lng);
    }
    if (request->hasArg(cfgKeyDWDWXFunction.c_str())) {
      dwdwx_fun = request->arg(cfgKeyDWDWXFunction).toInt();
      cfg_adjust(cfgKeyDWDWXFunction, dwdwx_fun);
    }
    
    cfg_write();
    redirectHomeResponse(request, "/#dwdwx");
  }
  #endif
  //
  static void setTimebeacon(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    int time_ric, time_fun;
    bool time_enable;
    int time_interval, time_mode;
    String time_zone;
    cfg_startTransaction();
    if (request->hasArg(cfgKeyTimeRIC.c_str())) {
      time_ric = request->arg(cfgKeyTimeRIC).toFloat();
      cfg_adjust(cfgKeyTimeRIC, time_ric);
    }
    if (request->hasArg(cfgKeyTimeFunction.c_str())) {
      time_fun = request->arg(cfgKeyTimeFunction).toInt();
      cfg_adjust(cfgKeyTimeFunction, time_fun);
    }
    if (request->hasArg(cfgKeyTimeEnable.c_str())) {
      time_enable = request->arg(cfgKeyTimeEnable).equals("on");
      cfg_adjust(cfgKeyTimeEnable, time_enable);
    } else {
      cfg_adjust(cfgKeyTimeEnable, false);
    }
    if (request->hasArg(cfgKeyTimeInterval.c_str())) {
      time_interval = request->arg(cfgKeyTimeInterval).toInt();
      cfg_adjust(cfgKeyTimeInterval, time_interval);
    }
    if (request->hasArg(cfgKeyTimeMode.c_str())) {
      time_mode = request->arg(cfgKeyTimeMode).toInt();
      cfg_adjust(cfgKeyTimeMode, time_mode);
    }
    if (request->hasArg(cfgKeyTimeZone.c_str())) {
      time_zone = request->arg(cfgKeyTimeZone);
      cfg_adjust(cfgKeyTimeZone, time_zone);
    }
    cfg_write();
    redirectHomeResponse(request, "/#timebeacon");
  }
  static void setIdlebeacon(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    bool idle_enable;
    int idle_interval, idle_mode;
    cfg_startTransaction();
    if (request->hasArg(cfgKeyIdleEnable.c_str())) {
      idle_enable = request->arg(cfgKeyIdleEnable).equals("on");
      cfg_adjust(cfgKeyIdleEnable, idle_enable);
    } else {
      cfg_adjust(cfgKeyIdleEnable, false);
    }
    if (request->hasArg(cfgKeyIdleInterval.c_str())) {
      idle_interval = request->arg(cfgKeyIdleInterval).toInt();
      cfg_adjust(cfgKeyIdleInterval, idle_interval);
    }
    if (request->hasArg(cfgKeyIdleMode.c_str())) {
      idle_mode = request->arg(cfgKeyIdleMode).toInt();
      cfg_adjust(cfgKeyIdleMode, idle_mode);
    }
    cfg_write();
    redirectHomeResponse(request, "/#idle");
  }
  //
  static void setDevCfg(AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    int oled_timeout;
    //
    cfg_startTransaction();
    if (request->hasArg(cfgKeyOLEDTimeout.c_str())) {
      oled_timeout = request->arg(cfgKeyOLEDTimeout).toInt();
      cfg_adjust(cfgKeyOLEDTimeout, oled_timeout);
    }
    if (request->hasArg(cfgKeyDeviceName.c_str())) {
        String device_name = request->arg(cfgKeyDeviceName);
        cfg_adjust(cfgKeyDeviceName, device_name);
    }
    cfg_write();
    redirectHomeResponse(request, "/#config");
  }
//
void webserver_setup(cfg_t *cfg) {
  webserver_protecc = cfg->webserver_protect;
  webserver_user = cfg->ap_ssid;
  webserver_pass = cfg->ap_pass;

  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
    {
      if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
        return request->requestAuthentication();
    AsyncWebServerResponse *response = request->beginResponse_P(
        200, "text/html", data_index_html_start,
        data_index_html_end - data_index_html_start - 1);
    response->addHeader("Access-Control-Allow-Origin", "*");
    request->send(response);
  });
  server.on("/script.js", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    AsyncWebServerResponse *response = request->beginResponse_P(
        200, "application/javascript", data_script_js_start,
        data_script_js_end - data_script_js_start - 1);
    response->addHeader("Access-Control-Allow-Origin", "*");
    request->send(response);
  });
  server.on("/style.css", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    AsyncWebServerResponse *response = request->beginResponse_P(
        200, "text/css", data_style_css_start,
        data_style_css_end - data_style_css_start - 1);
    response->addHeader("Access-Control-Allow-Origin", "*");
    request->send(response);
  });
  server.on("/config.json", HTTP_GET, [](AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String output = cfg_tostring();
    AsyncWebServerResponse *response =
        request->beginResponse(200, "application/json", output);
    response->addHeader("Access-Control-Allow-Origin", "*");
    request->send(response);
  });
  server.on("/contacts.json", HTTP_GET, [](AsyncWebServerRequest *request) {
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    String output = contacts_tostring();
    AsyncWebServerResponse *response =
        request->beginResponse(200, "application/json", output);
    response->addHeader("Access-Control-Allow-Origin", "*");
    request->send(response);
  });
  server.on("/contacts.json", HTTP_POST, [](AsyncWebServerRequest * request){
    if (webserver_protecc && !request->authenticate(webserver_user, webserver_pass))
      return request->requestAuthentication();
    if (request->hasParam("body", true)) { // This is important, otherwise the sketch will crash if there is no body
      contacts_write(request->getParam("body", true)->value());
      request->send(200, "text/plain", "ok\n");
    } else {
      Serial.println("No body?!");
      request->send(200, "text/plain", "No body?!\n");
    }
  });

  server.on("/setap", setAPCfg);
  server.on("/setwifi1", setWifi1Cfg);
  server.on("/setwifi2", setWifi2Cfg);
  server.on("/settransmitter", setTransmitterCfg);
  server.on("/setmqtt", setMQTTCfg);
  #if (defined(SMART_POC_MODULE_DWD) || defined(SMART_POC_MODULE_MOWAS))
  server.on("/setdwdmowas", setDWDMoWaS);
  #endif
  #ifdef SMART_POC_MODULE_DWD_WX
  server.on("/setdwdwx", setDWDWX);
  #endif
  server.on("/settimebeacon", setTimebeacon);
  server.on("/setidlebeacon", setIdlebeacon);
  server.on("/setdev", setDevCfg);

  server.on("/page", insertPage);
  server.on("/trigger-time", triggerTimeBeacon);
  server.on("/transmit", transmit);
  server.on("/clear", clearQueue);
  server.on("/rstcfgrbt", resetConfigReboot);
  server.on("/reboot", justReboot);

  server.onNotFound(handleNotFound);
  server.begin();
}